//+------------------------------------------------------------------+
//|                                                 EABreakout-2.mq4 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql4.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

#define MAGICBR 123
//===============================================================================
color         LineColor     = Yellow;
int           LineStyle     = 0;
string        LineStyleInfo = "0=Solid,1=Dash,2=Dot,3=DashDot,4=DashDotDot";
string        LineText      = "Range ";
string        LineText2     = "Range ";

extern double Top_Line      = 0;
extern double Bottom_Line   = 0;

extern double TakeProfitRatio = 90;
extern double Lots            = 0.1;
extern double EntryRatio      = 30;

double pHigh;
double pLow;
double RSpace;
double Above;
double Below;

//===============================================================================
//Fungsi untuk menghitung besaran pip
int CalculatePip(double b1, double b2)
{
   int result = int(MathRound((b1 - b2) / Point));
   return result;
}

//===============================================================================
//Fungsi untuk membuat objek garis horizontal
void DrawLines()
{
   double digit = MarketInfo(Symbol(), MODE_DIGITS);
   if(digit == 2)
   {
      RSpace  = CalculatePip(Top_Line, Bottom_Line);
      RSpace /= 100;
   }
   else if(digit == 3)
   {
      RSpace  = CalculatePip(Top_Line, Bottom_Line);
      RSpace /= 1000;
   }
   else if(digit == 4)
   {
      RSpace  = CalculatePip(Top_Line, Bottom_Line);
      RSpace /= 10000;
   }
   else if(digit == 5)
   {
      RSpace  = CalculatePip(Top_Line, Bottom_Line);
      RSpace /= 100000;
   }
   
   Above = MathRound(110*pHigh)/100;
   Below = MathRound(90*pLow)/100;
   
   for(double i=Top_Line; i<Above; i+=RSpace)
   {
      string StringNr = DoubleToStr(i, Digits); // 2 digits number in object name
      ObjectCreate(LineText+StringNr, OBJ_HLINE, 0, 0, i);
      ObjectSet(LineText+StringNr, OBJPROP_STYLE, LineStyle);
      ObjectSet(LineText+StringNr, OBJPROP_COLOR, LineColor);
   }
   
   for(double i=Bottom_Line; i>Below; i-=RSpace)
   {
      string StringNr = DoubleToStr(i, Digits); // 2 digits number in object name
      ObjectCreate(LineText2+StringNr, OBJ_HLINE, 0, 0, i);
      ObjectSet(LineText2+StringNr, OBJPROP_STYLE, LineStyle);
      ObjectSet(LineText2+StringNr, OBJPROP_COLOR, LineColor);
   }
   WindowRedraw();
}

//Fungsi untuk hapus objek garis
void RemoveLines()
{
   Above   = MathRound(110*pHigh)/100;
   Below   = MathRound(90*pLow)/100;
   RSpace  = CalculatePip(Top_Line, Bottom_Line);
   RSpace /= 100000;
   
   for(double i=Top_Line; i<Above; i+=RSpace)
   {
      ObjectDelete(LineText+DoubleToStr(i,Digits));
   }
   
   for(double i=Bottom_Line; i>Below; i-=RSpace)
   {
      ObjectDelete(LineText2+DoubleToStr(i,Digits));
   }
}
//===============================================================================

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
//---
   string strPip = "";
   int intPip = CalculatePip(Top_Line, Bottom_Line) / 10;
   
   pHigh = NormalizeDouble( High[iHighest(NULL,0,MODE_HIGH,Bars-1,0)], Digits );
   pLow  = NormalizeDouble( Low[iLowest(NULL,0,MODE_LOW,Bars-1,0)], Digits );
   DrawLines();
   
   strPip = IntegerToString(intPip, 0);
   Alert(Symbol() + "\nBesaran Range : " + strPip);
//---
   return(INIT_SUCCEEDED);
}
//+----------------------------------z--------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
//---
   RemoveLines();
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
//---
   FAccountStatus();
   //check for history and trading
   if(Bars<100 || IsTradeAllowed()==false)
      return;
   //Open order hanya tick pertama bar baru
   if(Volume[0]>1) return;
   
   bool buysignalt  = BuySignalT();
   bool buysignalb  = BuySignalB();
   bool sellsignalt = SellSignalT();
   bool sellsignalb = SellSignalB();
   
   if(buysignalt == true)
   {
      FOrderT(OP_BUYSTOP);
   }
   if(sellsignalt == true)
   {
      FOrderT(OP_SELLSTOP);
   }
   if(buysignalb == true)
   {
      FOrderB(OP_BUYSTOP);
   }
   if(sellsignalb == true)
   {
      FOrderB(OP_SELLSTOP);
   }
}
//+------------------------------------------------------------------+

//===============================================================================
void FAccountStatus()
{
   double balance = AccountBalance();
   double equity  = AccountEquity();
   Comment("Account Balance : ",balance,"\nAccount Equity : ",equity);
}

//===============================================================================
//Fungsi untuk sinyal buy
bool BuySignalT() //Top Line
{
   bool result = false;
   double LResistance = 0;
   
   for(double i=Top_Line; i<Above; i+=RSpace)
   {
      LResistance = i;
      if(iOpen(Symbol(),0,1) < LResistance 
      && iClose(Symbol(),0,1) > LResistance
      && iOpen(Symbol(),0,2) < LResistance
      && iClose(Symbol(),0,2) < LResistance
      && iOpen(Symbol(),0,3) < LResistance
      && iClose(Symbol(),0,3) < LResistance)
      {
         result = true;  
      }
   }
   return(result);
}

bool BuySignalB() //Bottom Line
{
   bool result = false;
   double LResistance = 0;
   
   for(double i=Bottom_Line; i>Below; i-=RSpace)
   {
      LResistance = i;
      if(iOpen(Symbol(),0,1) < LResistance 
      && iClose(Symbol(),0,1) > LResistance
      && iOpen(Symbol(),0,2) < LResistance
      && iClose(Symbol(),0,2) < LResistance
      && iOpen(Symbol(),0,3) < LResistance
      && iClose(Symbol(),0,3) < LResistance)
      {
         result = true;  
      }
   }
   return(result);
}

//===============================================================================
//Fungsi untuk sinyal sell
bool SellSignalT() //Top Line
{
   bool result = false;
   double LSupport = 0;
   
   for(double i=Top_Line; i<Above; i+=RSpace)
   {
      LSupport = i;
      if(iOpen(Symbol(),0,1) > LSupport 
      && iClose(Symbol(),0,1) < LSupport
      && iOpen(Symbol(),0,2) > LSupport
      && iClose(Symbol(),0,2) > LSupport
      && iOpen(Symbol(),0,3) > LSupport
      && iClose(Symbol(),0,3) > LSupport)
      {
         result = true;
      }
   }
   return(result);
}

bool SellSignalB() //Bottom Line
{
   bool result = false;
   double LSupport = 0;
   
   for(double i=Bottom_Line; i>Below; i-=RSpace)
   {
      LSupport = i;
      if(iOpen(Symbol(),0,1) > LSupport 
      && iClose(Symbol(),0,1) < LSupport
      && iOpen(Symbol(),0,2) > LSupport
      && iClose(Symbol(),0,2) > LSupport
      && iOpen(Symbol(),0,3) > LSupport
      && iClose(Symbol(),0,3) > LSupport)
      {
         result = true;
      }
   }
   return(result);
}

//===============================================================================
//Fungsi order
void FOrderT(int command) //Top Line
{
   double TakeProfitPoint = 0;
   double StopLossPoint   = 0;
   double PriceOrderPoint = 0;
   double RangeLine       = 0;
   
   double bRange = double(CalculatePip(Top_Line, Bottom_Line));
   double bEntry = bRange * EntryRatio / 100;
   double bTP    = bRange * TakeProfitRatio / 100;
   int ticket;
   
   for(double i=Top_Line; i<Above; i+=RSpace)
   {
      RangeLine = i;
      //buy
      if(command==OP_BUYSTOP)
      {
         if(iOpen(Symbol(),0,1) < RangeLine 
         && iClose(Symbol(),0,1) > RangeLine)
         {
            PriceOrderPoint = RangeLine+bEntry*Point;
            TakeProfitPoint = RangeLine+bTP*Point;
            StopLossPoint   = RangeLine;
            ticket          = OrderSend(Symbol(),command,Lots,PriceOrderPoint,3,StopLossPoint,TakeProfitPoint,"Buy",MAGICBR,0,Green);
         }
      }
      //sell
      if(command==OP_SELLSTOP)
      {
         if(iOpen(Symbol(),0,1) > RangeLine 
         && iClose(Symbol(),0,1) < RangeLine)
         {
            PriceOrderPoint = RangeLine-bEntry*Point;
            TakeProfitPoint = RangeLine-bTP*Point;
            StopLossPoint   = RangeLine;
            ticket          = OrderSend(Symbol(),command,Lots,PriceOrderPoint,3,StopLossPoint,TakeProfitPoint,"Sell",MAGICBR,0,Green);
         }
      }
   }
}

void FOrderB(int command) //Bottom Line
{
   double TakeProfitPoint = 0;
   double StopLossPoint   = 0;
   double PriceOrderPoint = 0;
   double RangeLine       = 0;
   
   double bRange = double(CalculatePip(Top_Line, Bottom_Line));
   double bEntry = bRange * EntryRatio / 100;
   double bTP    = bRange * TakeProfitRatio / 100;
   int ticket;
   
   for(double i=Bottom_Line; i>Below; i-=RSpace)
   {
      RangeLine = i;
      //buy
      if(command==OP_BUYSTOP)
      {
         if(iOpen(Symbol(),0,1) < RangeLine 
         && iClose(Symbol(),0,1) > RangeLine)
         {
            bEntry = bRange * EntryRatio / 100;
            PriceOrderPoint = RangeLine+bEntry*Point;
            TakeProfitPoint = RangeLine+bTP*Point;
            StopLossPoint   = RangeLine;
            ticket          = OrderSend(Symbol(),command,Lots,PriceOrderPoint,3,StopLossPoint,TakeProfitPoint,"Buy",MAGICBR,0,Green);
         }
      }
      //sell
      if(command==OP_SELLSTOP)
      {
         if(iOpen(Symbol(),0,1) > RangeLine 
         && iClose(Symbol(),0,1) < RangeLine)
         {
            bEntry = bRange * EntryRatio / 100;
            PriceOrderPoint = RangeLine-bEntry*Point;
            TakeProfitPoint = RangeLine-bTP*Point;
            StopLossPoint   = RangeLine;
            ticket          = OrderSend(Symbol(),command,Lots,PriceOrderPoint,3,StopLossPoint,TakeProfitPoint,"Sell",MAGICBR,0,Green);
         }
      }
   }
}
//===============================================================================
